#include <iostream>
#include <cassert>

#include "solver.hpp"

using namespace std;
using namespace sv;

int main(int argc, char* argv[])
{
	Model mdl;

	Var* vars = mdl.addVars(2);

	mdl.addConstr(vars[0] + vars[1], ConstrOper::LESS_EQUAL, 2);
	mdl.addConstr(vars[0] + vars[1], ConstrOper::GREATER_EQUAL, 1);
	mdl.addConstr(5 * vars[0] - 2 * vars[1], ConstrOper::GREATER_EQUAL, -2);

	mdl.setObjective(vars[0] + 2 * vars[1], MDL_MAXIMIZE);

	switch(mdl.optimize()) {
	case OPTIMAL:			
		cout << "OPTIMAL SOLUTION: " << mdl.get(DoubleAttr::Obj) << endl; 
		for (int i = 0; i < mdl.get(IntAttr::NumVars); i++) {
			cout << "var[" << i << "] : " << vars[i].get(DoubleAttr::X) << endl;
		}
		break;
	case INFEASIBLE:	
		cout << "INFEASIBLE MODEL" << endl;					
		break;
	case UNBOUNDED:	
		cout << "UNBOUNDED SOLUTION" << endl;			
		break;
	default:
		assert(false);
	}
	return 0;
}
